package com.plexworlds.l3.config

import com.plexworlds.l3.llm.Ollama
import com.intellij.openapi.options.SearchableConfigurable
import com.plexworlds.l3.llm.LLMs
import javax.swing.JComponent

class L3Config : SearchableConfigurable {

    private var panel: L3SettingsPanel? = null

    override fun createComponent(): JComponent {
        return L3SettingsPanel().also { panel = it }.mainPanel
    }

    override fun isModified(): Boolean {
        val panel = this.panel ?: return false
        val l3PersistentState = L3PersistentState.getInstance()
        return panel.modelField.text != l3PersistentState.model
//                || panel.urlField.text != l3State.url
    }

    override fun reset() {
        val panel = this.panel ?: return
        val l3PersistentState = L3PersistentState.getInstance()
        panel.modelField.text = l3PersistentState.model
        Ollama.changeModel(l3PersistentState.model)
    }

    override fun apply() {
        val panel = this.panel ?: return
        val state = L3PersistentState.getInstance()

        val llm = LLMs.valueOf(panel.providerComboBox.selectedItem as String).llm
        val model = panel.modelField.text

        llm.changeModel(model)

        state.provider = llm
        state.model = model
        state.url = panel.urlField.text

    }

    override fun disposeUIResources() {
        this.panel = null
    }

    override fun getDisplayName() = "AI code completion idea"
    override fun getId() = "com.plexworlds.l3.config.L3Config"
}
