package com.plexworlds.l3.config

import com.plexworlds.l3.llm.Ollama
import com.intellij.openapi.application.ApplicationManager
import com.intellij.openapi.components.PersistentStateComponent
import com.intellij.openapi.components.Storage
import com.intellij.openapi.components.State
import com.intellij.util.xmlb.XmlSerializerUtil
import com.plexworlds.l3.llm.Dummy
import com.plexworlds.l3.llm.LLM

@State(
    name = "com.plexworlds.l3.config.L3PersistentState",
    storages = [Storage("local-llama-link-plugin.xml")]
)
class L3PersistentState : PersistentStateComponent<L3PersistentState> {

    @JvmField
    var model: String = "codellama:7b-code"

    @JvmField
    var url: String = "http://localhost:11434"

    @JvmField
    var provider: LLM = Dummy

    override fun getState(): L3PersistentState = this

    override fun loadState(l3PersistentState: L3PersistentState) {
        XmlSerializerUtil.copyBean(l3PersistentState, this)
        Ollama.changeModel(l3PersistentState.model)
    }

    companion object {
        fun getInstance(): L3PersistentState {
            return ApplicationManager.getApplication().getService(L3PersistentState::class.java)
        }
    }
}
